<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div>

  <div class="modal-header">
    <h4
      class="modal-title"
      id="modal-basic-title"
      [innerText]="!!sealCertificate.id ? messages.EDIT_SEAL_CERTIFICATE_TITLE : messages.ADD_SEAL_CERTIFICATE_TITLE">
    </h4>
    <button
      type="button"
      class="btn-close"
      [title]="commonMessages.CLOSE"
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
  </div>

  <div class="modal-body">

    <form class="ls-form">

      <div class="form-group">
        <label
          for="nameInput"
          [innerText]="commonMessages.NAME">
        </label>

        <input
          id="nameInput"
          name="nameInput"
          [(ngModel)]="sealCertificate.name"
          type="text"
          class="form-control"
          required
          minlength="1"
          maxlength="255">
      </div>

      <div class="form-group">

        <label
          for="fileInput"
          [innerText]="messages.P12_FILE">
        </label>

        <div
          *ngIf="!pendingCertificateFile"
          class="row">

          <div class="col-6">
            <label
              for="issuerInfos"
              [innerText]="messages.ISSUER">
            </label>
            <app-x500-infos
              id="issuerInfos"
              [x500Infos]="sealCertificate.issuer">
            </app-x500-infos>
          </div>

          <div class="col-6">
            <label
              for="subjectInfos"
              [innerText]="messages.SUBJECT">
            </label>
            <app-x500-infos
              id="subjectInfos"
              [x500Infos]="sealCertificate.subject">
            </app-x500-infos>
          </div>

        </div>

      </div>

      <div>

        <button
          type="button"
          class="btn btn-sm btn-outline-info"
          (click)="certificateFileInput.click()">
          <fa-icon
            class="pe-2"
            [icon]="(!!sealCertificate.id || !!pendingCertificateFile) ? commonIcons.REPLACE_ICON : commonIcons.ADD_ICON">
          </fa-icon>
          {{ (!!sealCertificate.id || !!pendingCertificateFile) ? messages.FILE_REPLACE : messages.FILE_SELECTION }}
        </button>

        <!-- Hidden field, triggered by Bootstrap-designed buttons -->
        <input
          id="fileInput"
          name="fileIn"
          type="file"
          class="d-none"
          (change)="onCertificateFileChanged($event)"
          #certificateFileInput>

        <span
          *ngIf="!!pendingCertificateFile"
          class="ms-3"
          [innerText]="pendingCertificateFile.name">
        </span>

      </div>

      <div
        *ngIf="!sealCertificate.id || !!pendingCertificateFile"
        class="mt-3 form-group">
        <label
          for="passwordInput"
          [innerText]="commonMessages.PASSWORD">
        </label>

        <div class="input-group">

          <input
            id="passwordInput"
            name="passwordInput"
            [(ngModel)]="pendingPassword"
            [type]="hidePassword ? 'password' : 'text'"
            class="form-control"
            required
            minlength="2">

          <div
            class="input-group-text pointer"
            (click)="hidePassword = !hidePassword">
            <fa-icon
              class="hide-password-button text-center"
              [icon]="hidePassword? eyeIcon : eyeSlashIcon"
              [fixedWidth]="true">
            </fa-icon>
          </div>

        </div>
      </div>

      <div class="mt-3 form-group">
        <label
          for="signatureImageInput"
          [innerText]="messages.SEAL_EDIT_CERT_IMAGE">
        </label>

        <app-edit-signature
          id="signatureImageInput"
          [signatureImageSrc]="originalSignatureImageBlobSrc"
          (signatureChangedEvent)="onSignatureImageFileChanged($event)"
          (signatureDeleteEvent)="onSignatureImageFileDeleted()">
        </app-edit-signature>
      </div>

    </form>

  </div>

  <div class="modal-footer">
    <button
      ls-button-cancel
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
    <button
      ls-button-save
      (click)="onSaveButtonClicked()"
      [processing]="isProcessing">
    </button>
  </div>

</div>
